export type SortModel = {
  field: string;
  sort: 'asc' | 'desc';
};

export type Operator =
  // date | selectable
  | 'is'
  | 'not'
  | 'after'
  | 'onOrAfter'
  | 'before'
  | 'onOrBefore'
  // number
  | '='
  | '!='
  | '>'
  | '>='
  | '<'
  | '<='
  // common
  | 'contains'
  | 'equals'
  | 'startsWith'
  | 'endsWith'
  | 'isEmpty'
  | 'isNotEmpty'
  | 'isAnyOf';

export type FilterModelItem = {
  id: number;
  field: string;
  operator: Operator;
  value: string | string[] | undefined;
};

export type FilterModel =
  | {
      items: FilterModelItem[];
      logicOperator?: 'and' | 'or';
      quickFilterValues?: string[];
      quickFilterLogicOperator?: 'and' | 'or';
    }
  | undefined;
